--------------------------------------------------
-- Mir AI -> PvP Mod v0.1.2
--------------------------------------------------
-- This mod lets Mir AI to be used in PvP
-- it is just a sample, so don't expect too much
--------------------------------------------------
-- HOW TO ACTIVATE THIS MOD:
-- 1. open the Control Panel,
-- 2. choose the "Extra" Tab,
-- 3. and select PvP_Mod.lua

--------------------------------------------------
-- Extra Globals
--------------------------------------------------

--------------------------------------------------
function ModInit()
-- plugin initialization
--------------------------------------------------
	-- Mir AI functions replacement
	isKS = PvP_isKS
	GetMyEnemy_AttackingMe = PvP_Def_Scan
	GetMyEnemy_AnyNoKS = PvP_Atk_Scan
	GetEnemyOf = PvP_GetEnemyOf
end

--------------------------------------------------
function	PvP_isKS()
--------------------------------------------------
	return false -- there is no KS in PvP
end

--------------------------------------------------
function PvP_GetEnemyOf(id)
--------------------------------------------------
	local result = 0
	local actors = GetActors()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v ~= OwnerID) and (v ~= myid) and isNotFriend(v) then
			target = GetV(V_TARGET, v)
			if (target == id) then
				enemys[index] = v
				index = index + 1
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2(MyID, v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	return result
end

--------------------------------------------------
function	PvP_Def_Scan(myid)
--------------------------------------------------
	-- Log(string.format("---- DEFENSIVE SCAN STARTED for ID (%d)", myid))
	local result = 0
	local actors = GetActors()
	local enemy_std = {} -- normal targets
	local index_std = 1
	local player_target

	-- Fill a list of enemies who have me as target
	for i,v in ipairs(actors) do
		if GetV(V_MOTION, v) ~= MOTION_DEAD then
			if (v ~= OwnerID) and (v ~= MyID) and isNotFriend(v) then
				player_target = GetV(V_TARGET, v)
				if player_target == MyID then
					enemy_std[index_std] = v
					index_std = index_std + 1
   			end
			end
		end
	end

	-- Search for the closest aggressor -----------
   result = GetClosest(enemy_std)
	if result ~= 0 then
		Log(string.format("<defensive scan> Target found (ID %d):", result))
		TactBehav = BEHA_attack
		TactSkill = WITH_full_power
		TactLevel = 5
	end

	-- Log("---- END OF DEFENSIVE SCAN")
	return result
end

--------------------------------------------------
function	PvP_Atk_Scan(myid)
--------------------------------------------------
	-- Log(string.format("---- AGGRESSIVE SCAN STARTED for ID (%d)", myid))
	local result = 0
	local actors = GetActors ()
	local players = {}
	local player_idx = 1

	for i,v in ipairs(actors) do -- fill the (not "friend") player list
		if (v ~= OwnerID and v ~= MyID) then
			if isNotFriend(v) then
				players[player_idx] = v
				player_idx = player_idx + 1
			end
		end
	end

	-- Searches for nearest target ---------------
	result = GetClosest(players)
	if (result ~= 0) then
		Log(string.format("<aggressive scan> Target found (ID %d):", result))
		TactBehav = BEHA_attack
		TactSkill = WITH_full_power
		TactLevel = 5
	end

	BlockedPathToEnemyID = 0
	-- Log("---- END OF AGGRESSIVE SCAN")
	return result
end